<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-account-supervisor-circle</v-icon
            ><b>{{this.hasMethod('createCollaborativeWork') ? 'Gerenciar Equipes' : 'Ver Equipes'}}</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <!-- Edit mode -->
      <div class="scrollForm">
        <v-card-text class="px-4 mt-0">
          <!-- Equipes -->
          <div v-for="(team, index) in teams" :key="team._id" align="center" class="mb-3">
            <span class="teamTemplateHeader" style="position: relative">
              Equipe {{ index + 1 }}
              <v-tooltip v-if="hasMethod('createCollaborativeWork')" color="primary" bottom nudge-top="10px" >
                <template v-slot:activator="{ on }">
                  <v-icon
                  v-on="on"
                  class="mb-1"
                  style="position: absolute; right: -25px; top: 3px;"
                  color="primary"
                  small
                  @click="handleAddNewMember(team._id)"
                  >
                  mdi-plus-circle-outline</v-icon>
                </template>
                <span>Adicionar integrante</span>
              </v-tooltip>

              <v-tooltip v-if="hasMethod('createCollaborativeWork')" color="primary" bottom nudge-top="10px" >
                <template v-slot:activator="{ on }">
                  <v-icon        
                    small 
                    v-on="on" 
                    style="position: absolute; right: -45px; top: 3px;"
                    @click="deleteGroup(team)">mdi-delete</v-icon>
                </template>
                <span>Deletar grupo</span>
              </v-tooltip>

              <v-tooltip v-if="!hasMethod('createCollaborativeWork') && !(teams.some(team => team.participants.some(member => member.user._id === userLogged.id) ))" color="primary" bottom nudge-top="10px">
                <template v-slot:activator="{ on }">
                  <v-icon        
                    small
                    v-on="on" 
                    style="position: absolute; right: -30px; top: 3px;"
                    @click="handleUserEnterGroup(team._id)">mdi-account-plus</v-icon>
                </template>
                <span>Participar do grupo</span>
              </v-tooltip>

              <v-tooltip v-if="!hasMethod('createCollaborativeWork') && (team.participants.some ((member) => member.user._id === userLogged.id))" color="primary" bottom nudge-top="10px">
                <template v-slot:activator="{ on }">
                  <v-icon        
                    small
                    v-on="on" 
                    style="position: absolute; right: -30px; top: 3px; "
                    @click="handleUserExitGroup(team.participants)">mdi-account-remove</v-icon>
                </template>
                <span>Sair do grupo</span>
              </v-tooltip>
            </span>
            <br />
            <!-- Mostra caixa para selecionar novo usuario -->
            <v-row
              v-if="team._id == addNewUserOn"
              no-gutters
              justify="center"
              style="position: relative"
            >
              <div style="width: 50%; position: relative">
                <v-autocomplete
                  class="mb-2"
                  dense
                  v-model="selectedUser"
                  label="Selecione o usuário"
                  solo-inverted
                  flat
                  hide-no-data
                  hide-details
                  :items="usersList"
                  item-text="fullName"
                  item-value="id"
                ></v-autocomplete>

                <v-tooltip color="green" bottom nudge-top="13px">
                  <template v-slot:activator="{ on }">
                    <v-icon
                      :disabled="!selectedUser"
                      v-on="on"
                      class="pb-2 pl-2"
                      color="green"
                      style="position: absolute; left: 102%; top: 27%"
                      small
                      @click="addMember(team._id)"
                    >
                      mdi-check
                    </v-icon>
                  </template>
                  <span>Confirmar</span>
                </v-tooltip>

                <v-tooltip color="red" bottom nudge-top="13px">
                  <template v-slot:activator="{ on }">
                    <v-icon
                      v-on="on"
                      class="pb-2 pl-2"
                      color="red"
                      style="position: absolute; left: 112%; top: 27%"
                      small
                      @click="addNewUserOn = ''"
                    >
                      mdi-close
                    </v-icon>
                   
                  </template>
                  <span>Cancelar</span>
                </v-tooltip>
              </div>
            </v-row>
            <!-- Msg que não tem usuario no time -->
            <v-row v-if="team.participants.length == 0" no-gutters align="center" justify="center">
              <span
                ><v-icon small class="pb-1 pr-2">mdi-alert</v-icon>Essa equipe não possui nenhum
                integrante.</span
              >
            </v-row>
            <!-- Mostra usuarios da equipe -->
            <span
              v-for="(member, index) in team.participants"
              :key="member.user._id"
              style="line-height: 1.6rem;"
            >
              <v-row v-if="team.participants.length > 0" no-gutters align="center" justify="center">
                <v-col cols="1"></v-col>
                <v-col cols="7">
                  <v-row no-gutters style="position: relative;">
                    <v-icon v-if="index === 0" style="position: absolute; top: 0; bottom: 0; left: -17px" small color="warning" >mdi-star</v-icon>
                    <v-icon small class="mr-1">mdi-account</v-icon>{{ member.user.name }}
                    {{ member.user.surname }} ({{ member.user.matriculation }})
                  </v-row>
                </v-col>
                <v-col cols="3">
                  <v-btn v-if="hasMethod('createCollaborativeWork')" outlined color="primary" class="ml-2" x-small @click="removeUser(member)"
                    >Remover</v-btn
                  >
                </v-col>
                <br />
              </v-row>
            </span>
            <div style="font-size: 0.8rem; text-align: end; max-width: 83%" class="mt-5">
              Respostas enviadas: <b>{{ team.answers.length }}</b>
            </div>
            <v-divider class="mt-5" style="max-width: 85%" />
          </div>
        </v-card-text>
      </div>
      <v-card-actions class="mt-5 pb-6 pr-6">
        <v-spacer />
        <v-btn v-if="hasMethod('createCollaborativeWork')" color="lighter" text @click="handleClose">Cancelar</v-btn>
        <v-btn v-if="hasMethod('createCollaborativeWork')" color="primary" elevation="0" @click="createTeam">Criar novo time</v-btn>
      </v-card-actions>
    </v-card>
    <AlertConfirm
      :alert="alertCreateTeam"
      @clickCancelAlert="alertCreateTeam.status = false"
      @clickConfirmAlert="createTeamConfirmed"
    />
    <AlertConfirm
      :alert="alertRemove"
      @clickCancelAlert="alertRemove.status = false"
      @clickConfirmAlert="removeUserConfirmed"
    />
  </v-row>
</template>

<script>
import CollaborativeWork from '../../services/collaborativeWork'
import { mapGetters, mapState } from 'vuex'
export default {
  name: 'ManageTeams',

  components: {},

  props: {
    teams: {
      type: Array,
      default: () => {
        return []
      },
    },
    availableUsers: {
      type: Array,
      default: () => {
        return []
      },
    },
  },
  data: () => ({
    userInfo: '',
    userLogged: {},
    alertCreateTeam: {
      status: false,
      icon: 'mdi-account-group',
      message: 'Deseja <b>criar</b> uma nova equipe?',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    newTeamCheck: 0,
    alertRemove: {
      status: false,
      itemName: '',
      message: 'Deseja <b>remover</b> o integrante',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    userToRemove: {},
    removeCheck: 0,
    addNewUserOn: '',
    selectedUser: '',
    usersList: [],
  }),

  computed: {
    ...mapGetters('user', ['HAS_METHOD']),
    ...mapState({
      actionsMap: (state) => state.user.mappedActions,
      roles: (state) => state.user.rootEntities,
      methods: (state) => state.user.methods,
      modulesMaxManagements: state => state.user.modulesMaxManagements,
    },
    ),
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
  },

  watch: {
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        this.handleClose()
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },
    removeCheck() {
      this.alertRemove.status = false
    },
    newTeamCheck() {
      this.alertCreateTeam.status = false
    },
  },

  async created() {
    const userInfo = await this.$getItem('userInfo')
    this.userLogged = userInfo
    this.removeUsersFromList() // remove professor da lista de usuarios possiveis
  },

  methods: {
    ...mapGetters('user', ['HAS_METHOD']),

    hasMethod(name) {
      return this.methods.has(name)
    },

    //frontend
    async removeUsersFromList() {
      // retirando professor da lista de usuários

      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      this.usersList = this.availableUsers.filter((user) => {
        let check = 0
        user.entities.forEach((entity) => {
          if (entity.entity == entityId && entity.privileges.label == 'Professor') check++
        })
        if (check == 0) return user
      })

      // console.log(this.usersList, 'lista')
      // console.log(this.availableUsers, 'lista original')
    },

    handleClose() {
      this.$emit('closeMessage')
      this.addNewUserOn = ''
      this.selectedUser = ''
    },

    createTeam() {
      this.alertCreateTeam.status = true
    },

    createTeamConfirmed() {
      this.$emit('createNewTeam')
      this.newTeamCheck++
    },

    removeUser(user) {
      this.userToRemove = user
      this.alertRemove.status = true
      this.alertRemove.itemName = `${user.user.name} ${user.user.surname}`
    },
    
    removeUserConfirmed() {
      this.addNewUserOn = ''
      this.$emit('removeMemberFromTeam', this.userToRemove)
      this.removeCheck++
    },

    async handleUserExitGroup(teamParticipants){
     const userInfo = await this.$getItem('userInfo')

     const userToRemove = teamParticipants.filter(participants => participants.user.id === userInfo._id ? true : false)
          .shift()

      this.$emit('removeMemberFromTeam', userToRemove)
    },
    
    handleAddNewMember(teamId) {
      this.selectedUser = ''
      this.addNewUserOn = teamId
    },

    async handleUserEnterGroup(teamId){
      const userInfo = await this.$getItem('userInfo')
      const data = { teamId: teamId, participantId: userInfo.id }
      this.$emit('addMemberTeam', data)
    },

    addMember(teamId) {
      const data = { teamId: teamId, participantId: this.selectedUser }
      this.$emit('addMemberTeam', data)
      this.selectedUser = ''
      this.addNewUserOn = ''
    },

    deleteGroup(teamId){
      const data = {teamId: teamId}
      this.$emit('deleteTeam', data)
    },

    async deleteParticipant(answerId, teamId, participantId) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      let actionId
      if (actionsMap.get('collaborativeWorkUpdate'))
        actionId = actionsMap.get('collaborativeWorkUpdate').id
      else actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await CollaborativeWork.deleteParticipant(entityId, actionId, {
          answerId: answerId,
          teamId: teamId,
          participantId: participantId,
        })
        if (ret.success) {
          this.$emit('refreshTeamData')
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: this.messageRemove,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.handleSearch = true
      }
    },

    //backend
  },
}
</script>

<style>
.bold {
  font-weight: 501;
}
.styleTC {
  font-size: 1rem;
  font-weight: 300;
  line-height: 1.35rem;
}
.hoverReply > .v-icon:hover {
  color: #ffc107 !important;
}
.menuOn {
  animation: menuAppears 0.5s;
}

@keyframes menuAppears {
  from {
    transform: translateY(-35px);
    opacity: 0;
  }

  to {
    transform: translateY(0);
    opacity: 1;
  }
}
.buttonHoverTC > span > .v-btn:hover {
  background: #2a0845 !important;
  color: white !important;
}

.teamTemplateHeader {
  font-size: 1.1rem;
  font-weight: 700;
  color: rgba(0, 0, 0, 0.87);
  line-height: 3.3rem;
}
</style>
